function throttle(func, time) {
    clearTimeout(func._timeout);
    func._timeout=setTimeout(() => { func.call(); }, time);
}

function handle_date_change(e) {
    async function _handle_date_change() {
        value = e.target.value.trim()
        if (value === '') {
            _clear_all();
            return;
        }
        if (e.target.dataset.last === value) {
            return;
        }
        _set_format();
        _set_format();
        _set_status('One second...');
        var response = await fetch('/date?date=' + encodeURIComponent(value));
        var response_json = await response.json();
        format_strings = '';
        for (entry in response_json) {
            format_strings += '<p>' + response_json[entry] + '</p>';
        }
        if (format_strings) {
            _set_format(format_strings);
        } else {
            _set_status('Sorry, we couldn\'t interpret that.');
        }
        e.target.dataset.last = value;
    }
    throttle((e) => { _handle_date_change(e); }, 100);
}

function _clear_all() {
    document.querySelector('#status').innerHTML = '';
    document.querySelector('#format').innerHTML = '';
}

function _set_format(formats_html = '') {
    document.querySelector('#format').innerHTML = formats_html;
    _set_status();
}

function _set_status(status_html = '') {
    document.querySelector('#status').innerHTML = status_html;
}

var date_input = document.querySelector('#date');
date_input.addEventListener('focus', handle_date_change, false);
date_input.addEventListener('change', handle_date_change, false);
date_input.addEventListener('keydown', handle_date_change, false);
date_input.focus();
